'
'  SHIPLIB.BI Anticopyright (A) 1993 Brandon Bannerman
'  No rights reserved, except the right to messily and violently abuse with
'  a rusty cheese grater anyone who tries to rip me off. <Grin>
'  Patent Bending. Yes, I'm him, I'm the programmer from the arctic north!
'  Rrrroooar... I tear the patent up! Rrrriiip!
'  <Never mind, inside joke>
'This is the INCLUDE file for SHIPLIB.BAS/QLB/LIB. Refer to SHIPLIB.BAS for
'more info.
'I am officially releasing this source code to the Public Domain. Feel free
'to make as many copies as you want, and include this library into your own
'programs. I hereby grant permission to modify this source code for your own
'use, and include such modified code into your own programs, so long as you
'give credit where credit is due. I do ask that you not distribute modified
'copies of this code, except as part of your own programs, and that when you
'give copies of this to others that you give them unmodified copies.
'  Now that the legal drek is over with...
'
DECLARE FUNCTION TWTtoBST$ (TWText$)
DECLARE FUNCTION BSTtoTWT$ (BST$, LenTWT%)
  'Routines to convert a QB string to a Pascal string, and vice versa.
  'TWTtoBST converts Pascal strings (referred to here as TradeWarsText) to
  'BasicSTrings, and BSTtoTWT back. BSTtoTWT requires a second parameter,
  'which tells it the maximum length of the Pascal string (so it can fill any
  'unused space with ASCII 0).
DECLARE SUB Pstra (StringVal$)
  'An *extremely* handy routine I designed, which takes a string parameter,
  'parses all the TW2002 color codes in it, and prints the result, changing
  'colors along the way as necessary. See the actual routine for more info.
DECLARE FUNCTION GetKey$ (ValidChars$)
  'A single-character filtered input routine. See routine for more info.
DECLARE FUNCTION GetLin$ (MaxLen%, Valids$)
  'A filtered line input routine which uses GetKey. Note: changes the
  'foreground to yellow and the background to blue, creating a "field" which
  'shows the user how much space they have to type in, then changes the color
  'back to grey. If you wish to preserve your colors, or use your own, modify
  'the appropriate code. See routine for more info.
DECLARE FUNCTION DBLtoP6R$ (DBL#)
DECLARE FUNCTION P6RtoDBL# (P6R$)
  'Functions designed by Jason Boyd to convert between a QB double-precision
  'variable, and the hideously annoying Pascal "real" variables. Many thanx
  'to the Boyd individual for letting me download these routines from him
  'last year in exchange for the offsets of the Ship#9 alignment.

'
'Tell the user-defined TYPE ShipStat what to do with itself...
'

TYPE ShipStat
  HoldCost AS INTEGER
    'Holds portion of the ship's cost
  DrivCost AS INTEGER
    'Drive portion of the ship's cost
  CompCost AS INTEGER
    'Computer portion of the ship's cost
  HullCost AS INTEGER
    'Hull portion of the ship's cost
  MaxHolds AS INTEGER
    'Maximum Holds this shiptype can carry
  InitHolds AS INTEGER
    'Holds this shiptype starts with
  MoveRate AS STRING * 6
    'Pascal 6-byte real (Thnx to the Boydmeister), the percentage of the base
    'moves in Editor Option <G> this ship gets per day. The actual number of
    'turns in a 100-turn/day game.
  MaxFtr AS INTEGER
    'Maximum fighter load of this shiptype
  MaxShi AS INTEGER
    'Maximum shields this ship can be fitted with
  OffOdds AS INTEGER
    'Offensive odds * 10 (ie, 1.4:1 is stored as 14)
  MaxMines AS INTEGER
    'Maximum Mines this ship can carry
  MaxBeac AS INTEGER
    'Maximum beacons this ship can carry
  MaxGen AS INTEGER
    'Maximum Genesis torps this ship can carry
  LRS AS STRING * 1
    'If this ship can carry a long range scanner, this is equal to ASCII
    'character 1, otherwise it is 0. Setting it to 1 does little good on
    'ship #2 unless you've messed with it in AEdit.
  TWD AS STRING * 1
    'If this ship can carry a transwarp drive, this is equal to ASCII
    'character 1, otherwise it is 0.
  PLS AS STRING * 1
    'If this ship can carry a planet scanner, this is equal to ASCII
    'character 1, otherwise it is 0.
  Crap3 AS LONG
    'I have no clue. I dimensioned this as a LONG INT (which occipies 4 bytes)
    'instead of a STRING*4 to save string space in the compiler.
  MaxPHM AS INTEGER
    'Maximum photon missiles this ship can carry.
  MaxFtrAtt AS INTEGER
    'Maximum fighters this ship can use in one attack. Setting this above 9999
    'is extraneous in v1.03, since players can only use 4 characters of input
    'for this value.
  Crap4 AS LONG
    'Ditto Crap3.
END TYPE

'
'Dimension Variables...
'
DIM SHARED ShipType AS ShipStat
  'So that we can actually *use* the type of ShipStat.
DIM SHARED True AS INTEGER
DIM SHARED False AS INTEGER
  'Boolean variables. QB treats a value of 0 as False and a nonzero value as
  'True for logical operations.
DIM SHARED Upper AS STRING * 26
DIM SHARED Lower AS STRING * 26
DIM SHARED Alpha AS STRING * 52
DIM SHARED Numeric AS STRING * 10
DIM SHARED DOS AS STRING * 78
DIM SHARED Hexadecimal AS STRING * 22
  'Filters for the GetKey and GetLin subroutines, both of my design.
'
True = -1
False = 0
  'Define True and False. (Duh)
Upper = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
Lower = "abcdefghijklmnopqrstuvwxyz"
Alpha = Upper + Lower
Numeric = "0123456789"
DOS = Alpha + Numeric + "!@#$^&()_-{}.~`'"
Hexadecimal = Numeric + "ABCDEFabcdef"
  'Define the filters. For both GetKey and GetLin, you can combine strings or
  'even create your own filters--so long as you pass a string variable or a
  'null "" string, neither of them care.
'

