'
'  KITWORKS.BAS Anticopyright (A) 1993 Brandon Bannerman
'  No rights reserved, except the right to messily and violently abuse with
'  a rusty cheese grater anyone who tries to rip me off. <Grin>
'  Patent Bending. Yes, I'm him, I'm the programmer from the arctic north!
'  Rrrroooar... I tear the patent up! Rrrriiip!
'  <Never mind, inside joke>
'This is the source code to my KitWorks program, an accessory to ShipEdit
'designed to facilitate the easy manipulation of ShipKits. It requires the
'SHIPLIB.BI file in the current directory, and that you have the SHIPLIB.QLB
'and SHIPLIB.LIB files on hand. If you don't have them, you can create them
'from within QuickBasic 4.5 by selecting Make Library from the Run menu. The
'source to these libraries is in SHIPLIB.BAS.
'I am officially releasing this source code to the Public Domain. Feel free
'to make as many copies as you want, and include this library into your own
'programs. I hereby grant permission to modify this source code for your own
'use, and include such modified code into your own programs, so long as you
'give credit where credit is due. I do ask that you not distribute modified
'copies of this code, except as part of your own programs, and that when you
'give copies of this to others that you give them unmodified copies.
'  Now that the legal drek is over with...
'
DECLARE SUB ShowMenu ()
  'Prints out the main menu. Pretty straightforward use of Pstra.
DECLARE SUB Help ()
  'Help screen.
DECLARE SUB Summary ()
  'The ShipEdit/KitWorks summary screen.
DECLARE SUB InstKit (FiNa$, Mode%)
  'Installs a ShipKit. FiNa$ is the Kit to install. Mode% isn't really used
  'in InstKit this version, but I included it in case I choose to use it in
  'a future version.
DECLARE SUB PutData (FiNa$, Mode%)
  'Puts a ship record to FiNa$. If FiNa$ = "........", then it interprets
  'this to mean "put to TW2002", otherwise FiNa$ is interpreted as the name
  'of a ShipKit. The ship number is stored in the globally SHARED variable
  'ShipNum. If Mode% = 1, then this SUB gets the ship data from the WorkSpace,
  'otherwise it gets it from the "in transit" ship variables, used when
  'copying data that does not touch the WorkSpace.
DECLARE SUB MakeKit (FiNa$, Mode%)
  'Similar in operation to InstKit, except that Mode% works as in PutData and
  'the others. Note that the ShipKit must already be opened as file #5.
DECLARE SUB ParseCLine ()
  'A simple routine that parses the command line parameters.
DECLARE SUB GetData (FiNa$, Mode%)
  'Identical in operation to PutData, this is its inverse.
DECLARE SUB ParseShipFac ()
  'Parses the Ship Factors of the current ship.
DECLARE FUNCTION KitNum% ()
  'Calculates the BINARY offset of ShipNum in a ShipKit. I was lazy that day.
DECLARE FUNCTION SFill$ (StringVar$, MaxLen%)
  'SFill$ is a number of spaces equal to the MaxLen% minus the length of
  'StringVar$. Used for erasing extraneous output on the same screen, such
  'as if you'd just printed "1000", then wanted to print 12, you would:
  'PRINT "12"; SFill$("12", 4)
  'Actually, this is a function used a lot in ShipEdit--I don't think I
  'used it in KitWorks.
DECLARE FUNCTION CVal$ (IntVal%)
  'Abbreviation for C++ Val of IntVal%, this is a bitter tongue-in-cheek
  'reference to the fact that QB has an annoying habit of printing a space
  'before a positive integer (supposedly, where the + sign would go), even
  'though it doesn't use this except in a PRINT USING statement. C++, on the
  'other hand, does not. (At least, not that I'm aware of) Anyway, this
  'removes all leading and trailing spaces from an integer variable.
DECLARE FUNCTION CLon$ (LongVal&)
  'Same as above, except it parses a Long Int. Actually, I'm not sure if I
  'used either of these in KitWorks, either.
DEFINT A-Z
  'Define all undeclared variables starting with the letters A to Z as
  'integers.
'
'$INCLUDE: 'ShipLib.BI'
  'This is a metacommand which includes the file SHIPLIB.BI, which contains
  'all the variables and declarations for the ShipLib Library and Quick
  'Library.
'
ON ERROR GOTO Erred
  'I love these vague Label names, don't you?
CLS
Pstra ("~EShipEdit KitWorks Release Version ~D0.10~!~A")
PRINT "  Dimensioning Variables"
  'I put this running commentary on what the program in as a matter of
  'diagnosing any bugs that might pop up while I was designing this program.
  'I forgot to take them out, but found out later that people actually liked
  'knowing what the program was doing, so I kept them in.
'
'Dimension Fixed-Length Strings...
DIM SHARED FileHeader AS STRING * 25
DIM SHARED Names(0 TO 15) AS STRING * 23
DIM SHARED RawString AS STRING * 23
DIM SHARED Filename AS STRING * 8
DIM SHARED FromTW AS STRING * 8
DIM SHARED Work AS STRING * 12
DIM SHARED Blank AS STRING * 12
DIM SHARED Abbs(0 TO 15)  AS STRING * 6
DIM SHARED ShipAbb AS STRING * 6
DIM SHARED ColString AS STRING * 2
'...Bytes...
DIM SHARED Char AS STRING * 1
DIM SHARED TheChoice AS STRING * 1
DIM SHARED TheAns AS STRING * 1
DIM SHARED LoSh AS STRING * 1
'...Variable-Length Strings...
DIM SHARED NewVal AS STRING
DIM SHARED Parm(1 TO 5) AS STRING
DIM SHARED Cmd AS STRING
DIM SHARED NewPath AS STRING
'...Integers...
DIM SHARED WShipNum AS INTEGER
DIM SHARED EC AS INTEGER
DIM SHARED NumOfChars AS INTEGER
DIM SHARED MR AS INTEGER
DIM SHARED ColNum(1) AS INTEGER
DIM SHARED Align AS INTEGER
DIM SHARED ShipNum AS INTEGER
DIM SHARED V103D AS INTEGER
DIM SHARED Offset AS INTEGER
DIM SHARED WAlign AS INTEGER
'...Single-Precisions...
DIM SHARED Odds AS SINGLE
'...Longs...
DIM SHARED MMFac AS LONG
DIM SHARED OffFac AS LONG
DIM SHARED DefFac AS LONG
DIM SHARED ShipFac AS LONG
DIM SHARED ShipPrice AS LONG
'...and ShipTypes.
DIM SHARED WorkSpace(0 TO 15) AS ShipStat
'
FOR x = 0 TO 15
  Abbs(x) = "Unused"
NEXT x
'  This sets all of the WorkSpace ship abbreviations (which show up only in
'the summary) to "Unused", so that if by some ungodly bug someone got into
'the Summary or created a Kit before they'd loaded anything, it wouldn't be
'a null string.
'
V103D = False
'A boolean variable which tells the program whether to use v1.03 or v1.03D
'offsets for the executable files. It defaults to v1.03, but automatically
'detects v1.03D.
'
FromTW = "........"
'A constant mainly used in calls to the installation routines, this value as
'a filename tells KitWorks to install to/get from the TW2002 executables and
'datafiles.
'
PRINT "  Parsing Commandline"
CALL ParseCLine
'
IF NewPath = "" THEN
  NP$ = "current directory"
ELSE
  NP$ = LTRIM$(LEFT$(NewPath, LEN(NewPath) - 1))
END IF
PRINT "   - Getting all files from "; RTRIM$(NP$)
'NewPath stores the optional path that a user can specify on the commandline
'to get all files from. The above display strips the trailing backslash
'which KitWorks and ShipEdit both require on the commandline. I did this
'purely for aesthetic reasons.
'
PRINT "  Opening Files"
File$ = NewPath + "ShipStat.Dat"
OPEN File$ FOR RANDOM AS #1 LEN = 45
File$ = NewPath + "tw2002.exe"
OPEN File$ FOR BINARY AS #2
File$ = NewPath + "tedit.exe"
OPEN File$ FOR BINARY AS #3
File$ = NewPath + "tw2002.ovr"
OPEN File$ FOR BINARY AS #4
'------------------------ ! ! W A R N I N G ! ! ----------------------------
'This program modifies the Trade Wars 2002 executables! Don't use it; you
'might lose your registration, get sued, be reamed with a broomstick sans
'KY, be waxed with a rusty cheese grater, or something equally tasty that
'MarTech could think up. <Snicker>
'...relax, Gary, that was a joke.
'
IF LOF(2) = 87504 THEN
  V103D = True
ELSEIF LOF(2) = 86736 THEN
  V103D = False
ELSEIF LOF(2) = 0 THEN
  PRINT "  TW2002 Not Found"
  IF LOF(1) = 0 THEN
    CLOSE #1
    KILL (NewPath + "ShipStat.Dat")
  END IF
  IF LOF(2) = 0 THEN
    CLOSE #2
    KILL (NewPath + "TW2002.Exe")
  END IF
  IF LOF(3) = 0 THEN
    CLOSE #3
    KILL (NewPath + "Tedit.Exe")
  END IF
  IF LOF(4) = 0 THEN
    CLOSE #4
    KILL (NewPath + "TW2002.Ovr")
  END IF
  ERROR 201
ELSE
  PRINT "  TW2002.EXE Invalid Size"
  ERROR 202
END IF

IF V103D THEN
  PRINT "  TW2002 Version 1.03D Detected"
ELSE
  PRINT "  TW2002 Version 1.03 Standard Detected"
END IF
'This segment of code detects the following:
'  Whether TW2002 exists in this directory--KitWorks assumes that if
'    TW2002.EXE doesn't exist, neither does TW2002.
'  The version of TW2002. If it is neither 1.03D nor 1.03, then KitWorks
'    will quit with an error and tell the user the problem.
'
IF Backup THEN
  PRINT "   - Backing up shiptypes to {BACKUP}.KIT"
  CALL MakeKit("{BACKUP}", 0)
END IF
'Backing up the TW2002 shiptypes used to take the form of copying SHIPSTAT.DAT
'to SHIPSTAT.OLD. Now that I know ShipKits work, this takes the form of making
'a Kit called {BACKUP}.KIT, which is actually better--this saves the Ship#9
'alignment and Ship Names too.
'
DO
  'I'm not going to document the entire program; much of it is fairly self-
  'explanatory. When all else fails, if you don't understand it, mess it up
  'and see what goes wrong when you run it. <Grin>
  ShowMenu
  ZZ$ = UCASE$(GetKey("?QLICSEDqlicsed"))
    'That la-la-la-lovely GetKey routine again.
  SELECT CASE ZZ$
    CASE "Q"
      PRINT "Quit"
      EXIT DO
    CASE "?"
      PRINT "Help"
      Help
    CASE "I"
      PRINT "Install Kit"
      PRINT
      COLOR 10
      PRINT "This will install the a kit of your choice into the current TW2002 Game. This"
      Pstra ("is functionally equivalent to using the ~D/K:Kitfile ~Cparameter on ~DSHIPEDIT~C.")
      PRINT "You can cancel this operation by just hitting Enter."
      Pstra ("~E  Name of Kit to Install ~A(~B8 Characters~A) ~e: ")
      KK$ = UCASE$(GetLin(8, DOS))
      PRINT
      COLOR 15
      IF KK$ <> "" THEN
        Pstra ("~EInstalling ~D" + KK$ + ".KIT~E...")
        COLOR 10
        CALL InstKit(KK$, 0)
        IF NOT EC THEN PRINT "Done!"
      ELSE
        PRINT "Nothing Changed."
      END IF
    CASE "C"
      PRINT "Create Kit"
      PRINT
      Pstra ("~EMake Kit out of WorkSpace or TW2002 ShipTypes? ~A(~BW~A,~BT~A) ~D")
      WW$ = UCASE$(GetKey("WwTt"))
      IF WW$ = "W" AND Work = Blank THEN
        COLOR 12
        PRINT "There are no ships loaded into the WorkSpace."
      ELSE
        IF WW$ = "T" THEN
          PRINT "TW2002"
          Mode% = 0
        ELSE
          PRINT "WorkSpace"
          Mode% = 1
        END IF
        PRINT "You can cancel this operation by just hitting Enter."
        Pstra ("~E  Name of Kit to Create ~A(~B8 Characters~A) ~e: ")
        KK$ = UCASE$(GetLin(8, DOS))
        PRINT
        COLOR 15
        IF KK$ <> "" THEN
          OPEN NewPath + KK$ + ".KIT" FOR BINARY AS #5
          IF LOF(5) = 1083 THEN
            COLOR 12
            PRINT "That Kit Exists! Overwrite? (Y/N) ";
            COLOR 14
            YY$ = UCASE$(GetKey("YNyn"))
            IF YY$ = "Y" THEN
              PRINT "Sure"
              Pstra ("~ECreating ~D" + KK$ + ".KIT~E... ~C")
              CALL MakeKit(KK$, Mode%)
              IF NOT EC THEN PRINT "Done!"
            ELSE
              PRINT "NOT!"
            END IF
          ELSE
            Pstra ("~ECreating ~D" + KK$ + ".KIT~E... ~C")
            CALL MakeKit(KK$, Mode%)
            IF NOT EC THEN PRINT "Done!"
          END IF
        ELSE
          PRINT "Nothing Changed."
        END IF
        CLOSE #5
      END IF
    CASE "D"
      PRINT "Display ShipKits"
      PRINT
      Pstra ("~EShipEdit ~DShipKits ~Ein ~1")
      NP$ = NewPath + "*.KIT"
      FILES NP$
        'Note--QB will *always* show the current directory in the header, even
        'though the FILES statement is displaying the correct files. An
        'annoying QB bug.
    CASE "L"
      PRINT "Load Workspace"
      PRINT
      Pstra ("~ELoad from ~A[~BK~A]~Eit or ~A[~BT~A]~EW2002? ~A(~BEsc Aborts~A) ~D")
      TF$ = UCASE$(GetKey("KTkt" + CHR$(27)))
      SELECT CASE TF$
        CASE CHR$(27)
          COLOR 15
          PRINT "Nothing Loaded."
        CASE "T"
          PRINT "TW2002"
          Pstra ("~ELoading TW2002 set into WorkSpace... ~C")
          FOR ShipNum = 0 TO 15
            WShipNum = ShipNum
            CALL GetData(FromTW, 1)
          NEXT ShipNum
          PRINT "Done!"
          IF NOT EC THEN Work = FromTW + "...."
        CASE ELSE
          PRINT "Kit"
          Pstra ("~E  Name of Kit to Load ~A(~B8 Characters~A) ~e: ")
          KK$ = UCASE$(GetLin(8, DOS))
          IF KK$ <> "" THEN
            EC = 0
            PRINT
            Pstra ("~ELoading ~D" + KK$ + ".KIT~E...")
            COLOR 10
            FOR ShipNum = 0 TO 15
              WShipNum = ShipNum
              CALL GetData(KK$ + ".KIT", 1)
              IF EC THEN EXIT FOR
            NEXT ShipNum
            IF NOT EC THEN
              KK$ = KK$ + ".KIT"
              Work = KK$
              PRINT "Done!"
            END IF
          ELSE
            COLOR 15
            PRINT "Nothing Done."
          END IF

      END SELECT
    CASE "S"
      PRINT "Summary"
      IF Work <> Blank THEN
        Summary
        CLS
      ELSE
        COLOR 12
        PRINT "There are no ships loaded into the WorkSpace."
      END IF
    CASE "E"
      PRINT "Extract Ships"
      DO
      IF Work <> "        " THEN
        Pstra ("~EExtract Ships To or From WorkSpace ~A(~BEsc Aborts~A) ~e: ~D")
        TT$ = UCASE$(GetKey("TFtf" + CHR$(27)))
        SELECT CASE TT$
          CASE CHR$(27)
            COLOR 15
            PRINT "Aborted. Nothing Done."
          CASE "T"
            PRINT "To WorkSpace"
            Which$ = " from "
          CASE ELSE
            PRINT "From WorkSpace"
            Which$ = " to "
        END SELECT
        IF TT$ <> CHR$(27) THEN
          Pstra ("~ELoad" + Which$ + "~A[~BK~A]~Eit or ~A[~BT~A]~EW2002? ~A(~BEsc Aborts~A) ~D")
          TF$ = UCASE$(GetKey("KTkt" + CHR$(27)))
          SELECT CASE TF$
            CASE CHR$(27)
              COLOR 15
              PRINT "Nothing Loaded."
              EXIT DO
            CASE "T"
              PRINT "TW2002"
              FiNa$ = "........"
            CASE ELSE
              PRINT "Kit"
              Pstra ("~E  Name of Kit to Extract" + Which$ + "~A(~B8 Characters~A) ~e: ")
              KK$ = UCASE$(GetLin(8, DOS))
              IF KK$ <> "" THEN
                FiNa$ = KK$ + ".KIT"
              ELSE
                COLOR 15
                PRINT "Nothing Done."
                EXIT DO
              END IF
          END SELECT
          IF KK$ <> "" THEN
            Pstra ("~EExtract from which ship number ~A(~B0 - 15) ~e: ")
            FWS% = VAL(GetLin(2, Numeric))
            PRINT
            IF FWS% >= 0 AND FWS% < 16 THEN
              Pstra ("~EExtract this into which ship number ~A(~B0 - 15) ~e: ")
              TWS% = VAL(GetLin(2, Numeric))
              PRINT
              IF TWS% >= 0 AND TWS% < 16 THEN
                COLOR 9
                IF TT$ = "T" THEN
                  EC = 0
                  PRINT "Copying " + FiNa$ + " Ship #"; STR$(FWS%); " onto WorkSpace Ship #"; STR$(TWS%); "...";
                  WShipNum = TWS%
                  ShipNum = FWS%
                  CALL GetData(FiNa$, 1)
                  IF NOT EC THEN PRINT "Done!"
                ELSE
                  EC = 0
                  PRINT "Copying WorkSpace Ship #"; STR$(FWS%); " onto " + FiNa$ + " Ship #"; STR$(TWS%); "... ";
                  ShipNum = TWS%
                  WShipNum = FWS%
                  CALL PutData(FiNa$, 1)
                  IF NOT EC THEN PRINT "Done!"
                END IF
              ELSE
                COLOR 12
                PRINT "Invalid Range."
              END IF
            ELSE
              COLOR 12
              PRINT "Invalid Range."
            END IF
          END IF
        END IF
        EXIT DO
      ELSE
        COLOR 12
        PRINT "There are no ships loaded into the WorkSpace."
        EXIT DO
      END IF
      LOOP
  END SELECT
LOOP

GOTO Finis
'
Erred:
  'My simple error-trapping routine. Some of the nastier errors will leave
  'KitWorks with an error still, but I trapped what I thought were the only
  'ones you'd normally encounter.
COLOR 12
IF ERR = 201 THEN
  COLOR 12
  PRINT "Trade Wars 2002 was NOT found in this directory!"
  PRINT "(This, by the way, is a fairly serious boo-boo)"
  COLOR 14
  PRINT "  ShipEdit must be run either in your TradeWars 2002 directory, or in one which"
  PRINT "has ALL of the following files:"
  COLOR 13
  PRINT "  - SHIPSTAT.DAT - 720 bytes"
  PRINT "  - TW2002.EXE - 87504 bytes in v1.03D, 86736 bytes in v1.03"
  PRINT "  - TW2002.OVR - 347562 bytes in v1.03D, 347511 bytes in v1.03"
  PRINT "  - TEDIT.EXE - 64224 bytes in v1.03D, 63104 bytes in v1.03"
  COLOR 14
  PRINT "  In addition to any ShipKits, which must have an extension of .KIT and be 1083"
  PRINT "bytes in length. Please rectify this error."
  RESUME Ender
ELSEIF ERR = 202 THEN
  COLOR 12
  PRINT "TW2002.EXE was invalid!"
  COLOR 14
  PRINT "  ShipEdit determines the version of TW2002 by looking at the size of the"
  PRINT "TW2002.EXE file. In version 1.03D, this file is 87504 bytes long, and in the"
  PRINT "original version 1.03 standard, it is 86736 bytes long. Your TW2002.EXE was"
  PRINT "NEITHER."
  COLOR 5
  PRINT "  1.03 and 1.03D are the only versions currently supported by ShipEdit. If you"
  PRINT "have an earlier version, ";
  COLOR 13
  PRINT "please upgrade."
  RESUME Ender
ELSE
  CLS
  PRINT "Errorlevel"; ERR; "occurred at "; TIME$; " on "; DATE$; "."
  RESUME Ender
END IF
Finis:
COLOR 11
PRINT "KitWorks Release Version 0.10"
PRINT "Compiled 04/19/93 07:47 PM in Microsoft QuickBasic v4.5"
PRINT "Released to the Public Domain :"
PRINT "  Anticopyright (A) 1993 Brandon Bannerman"
PRINT "  No rights reserved (except the right to abuse anyone distributing hacks)"
PRINT "  Distribute all you frothing like. This thing is free."
PRINT "Support Board - DarkStar StarDock @ (206)431-1243"
PRINT "See KITWORKS.DOC for more information."
'
Ender:
'I'm an Orson Scott Card fan; I've always felt obligated to include this
'rather fitting label as my GOTO to terminate the program.
'
END

DEFSNG A-Z
FUNCTION CLon$ (LongVal&)
CLon$ = RTRIM$(LTRIM$(STR$(LongVal&)))
END FUNCTION

FUNCTION CVal$ (IntVal%)
CVal$ = RTRIM$(LTRIM$(STR$(IntVal%)))
END FUNCTION

SUB GetData (From$, Mode%)

IF From$ = "........" THEN
  IF V103D THEN
    GET #2, 85399 + (ShipNum * 23), RawString
    GET #2, 84612 + (ShipNum * 7), ShipAbb
    IF ShipNum = 9 THEN GET #4, 238171, Align
  ELSE
    GET #2, 84654 + ((ShipNum - 1) * 23), RawString
    GET #2, 83851 + ((ShipNum - 1) * 7), ShipAbb
    IF ShipNum = 9 THEN GET #4, 238152, Align
  END IF
  GET #1, ShipNum + 1, ShipType
  Odds = ShipType.OffOdds / 10
  MR = 100 * (P6RtoDBL(ShipType.MoveRate))
  Holds& = ShipType.HoldCost
  Drive& = ShipType.DrivCost
  Compu& = ShipType.CompCost
  Hulls& = ShipType.HullCost
  ShipPrice = Holds& + Drive& + Compu& + Hulls&
ELSE
  OPEN NewPath + From$ FOR BINARY AS #6
  IF LOF(6) > 25 THEN GET #6, 1, FileHeader
  IF LOF(6) = 0 THEN
    CLOSE #6
    KILL NewPath + From$
    COLOR 12
    PRINT "Failed!"
    PRINT LTRIM$(RTRIM$(From$)) + " does not exist."
    EC = -1
    EXIT SUB
  ELSEIF LOF(6) <> 1083 OR FileHeader <> "TW2002 ShipEdit Kit File" + CHR$(26) THEN
    COLOR 12
    PRINT "Failed!"
    CLOSE #6
    PRINT LTRIM$(RTRIM$(From$)) + " was an invalid ShipKit."
    EC = -1
    EXIT SUB
  END IF
  GET #6, 26, Align
  GET #6, KitNum, RawString
  GET #6, KitNum + 23, ShipAbb
  GET #6, KitNum + 29, ShipType.HoldCost
  GET #6, KitNum + 31, ShipType.DrivCost
  GET #6, KitNum + 33, ShipType.CompCost
  GET #6, KitNum + 35, ShipType.HullCost
  GET #6, KitNum + 37, ShipType.MaxHolds
  GET #6, KitNum + 39, ShipType.InitHolds
  GET #6, KitNum + 41, ShipType.MoveRate
  GET #6, KitNum + 47, ShipType.MaxFtr
  GET #6, KitNum + 49, ShipType.MaxShi
  GET #6, KitNum + 51, ShipType.OffOdds
  GET #6, KitNum + 53, ShipType.MaxMines
  GET #6, KitNum + 55, ShipType.MaxBeac
  GET #6, KitNum + 57, ShipType.MaxGen
  GET #6, KitNum + 59, ShipType.LRS
  GET #6, KitNum + 60, ShipType.TWD
  GET #6, KitNum + 61, ShipType.PLS
  GET #6, KitNum + 62, ShipType.MaxPHM
  GET #6, KitNum + 64, ShipType.MaxFtrAtt
  CLOSE #6
END IF

IF Mode% = 1 THEN
  WorkSpace(WShipNum) = ShipType
  Abbs(WShipNum) = ShipAbb
  Names(WShipNum) = RawString
  IF WShipNum = 9 THEN WAlign = Align
END IF

END SUB

SUB Help
CLS
COLOR 14
PRINT "KitWorks is a program designed to help you more easily manipulate and use your"
PRINT "ShipEdit ShipKits. Within it, you can install, create, and modify nearly any"
PRINT "aspect of a ShipKit. You can cut and paste ships to and from Kits, the"
PRINT "workspace you have ships loaded into, and/or TW2002 itself. Note: KitWorks can"
PRINT "not edit the ships themselves--you use ShipEdit for that."
Pstra ("  ~A<~BI~A] ~E- Install an existing ShipKit on this TW2002 game. Identical in function~!")
PRINT "        to using the /K:Kitfile parameter on SHIPEDIT.EXE."
Pstra ("  ~A<~BC~A] ~E- Creates a ShipKit from the TW2002 shiptypes. Identical to the ~D* ~Ekey~!")
PRINT "        from within ShipEdit, except that you can also make a Kit from the"
PRINT "        ships in the WorkSpace."
Pstra ("  ~A<~BE~A] ~E- Extract ships. Here, you can pull any ship out of TW2002, a ShipKit,~!")
PRINT "        or the WorkSpace, and paste it into any other. This can be VERY handy,"
PRINT "        for those times when you only want to put one ship instead of an entire"
PRINT "        Kit."
Pstra ("  ~A<~BL~A] ~E- Loads a set of ships into the WorkSpace from either TW2002 or a Kit.~!")
Pstra ("  ~A<~BS~A] ~E- Shows a Summary screen of the shiptypes in the WorkSpace. This is~!")
PRINT "        identical to the screen in ShipEdit."
PRINT
COLOR 15
PRINT "Press Any Key to Return to KitWorks"
ZZ$ = GetKey("")
CLS
END SUB

SUB InstKit (FiNa$, Mode%)
FiNa$ = FiNa$ + ".KIT"
OPEN NewPath + FiNa$ FOR BINARY AS #5

IF LOF(5) > 25 THEN GET #5, 1, FileHeader

IF LOF(5) = 0 THEN
  CLOSE #5
  KILL NewPath + FiNa$ + ".KIT"
  COLOR 12
  PRINT "Failed!"
  PRINT LTRIM$(RTRIM$(FiNa$)) + ".KIT does not exist."
  EXIT SUB
  ELSEIF LOF(5) <> 1083 OR FileHeader <> "TW2002 ShipEdit Kit File" + CHR$(26) THEN
  COLOR 12
  PRINT "Failed!"
  CLOSE #5
  PRINT LTRIM$(RTRIM$(FiNa$)) + " was an invalid ShipKit."
  EXIT SUB
END IF

CLOSE #5

FOR ShipNum = 0 TO 15
  CALL GetData(FiNa$, Mode%)
  CALL PutData("........", Mode%)
NEXT ShipNum
END SUB

FUNCTION KitNum%
KitNum = (28 + (ShipNum) * 67&) - ShipNum
END FUNCTION

SUB MakeKit (FiNa$, Mode%)

FileHeader = "TW2002 ShipEdit Kit File" + CHR$(26)
PUT #5, 1, FileHeader
PUT #5, 26, Align
SNum% = ShipNum
FOR ShipNum = 0 TO 15
 
  IF Mode% = 1 THEN
    ShipType = WorkSpace(ShipNum)
    ShipAbb = Abbs(ShipNum)
    RawString = Names(ShipNum)
    Align = WAlign
  ELSE
    CALL GetData(FromTW, Mode%)
  END IF

  PUT #5, KitNum, RawString
  PUT #5, KitNum + 23, ShipAbb
  PUT #5, KitNum + 29, ShipType.HoldCost
  PUT #5, KitNum + 31, ShipType.DrivCost
  PUT #5, KitNum + 33, ShipType.CompCost
  PUT #5, KitNum + 35, ShipType.HullCost
  PUT #5, KitNum + 37, ShipType.MaxHolds
  PUT #5, KitNum + 39, ShipType.InitHolds
  PUT #5, KitNum + 41, ShipType.MoveRate
  PUT #5, KitNum + 47, ShipType.MaxFtr
  PUT #5, KitNum + 49, ShipType.MaxShi
  PUT #5, KitNum + 51, ShipType.OffOdds
  PUT #5, KitNum + 53, ShipType.MaxMines
  PUT #5, KitNum + 55, ShipType.MaxBeac
  PUT #5, KitNum + 57, ShipType.MaxGen
  PUT #5, KitNum + 59, ShipType.LRS
  PUT #5, KitNum + 60, ShipType.TWD
  PUT #5, KitNum + 61, ShipType.PLS
  PUT #5, KitNum + 62, ShipType.MaxPHM
  PUT #5, KitNum + 64, ShipType.MaxFtrAtt
NEXT ShipNum
ShipNum = SNum%
END SUB

DEFINT A-Z
SUB ParseCLine
Cmd = COMMAND$
Words = 0
in = False
StrLen = LEN(Cmd)
FOR Chr = 1 TO StrLen
  CutItOut$ = MID$(Cmd, Chr, 1)
  IF CutItOut$ <> "/" THEN
    IF NOT in THEN
      IF Words = 5 THEN EXIT FOR
      Words = Words + 1
      in = True
    END IF
    Parm$(Words) = Parm$(Words) + CutItOut$
  ELSE
    in = False
  END IF
NEXT Chr
FOR x = 1 TO 3
  Parm$(x) = RTRIM$(LTRIM$(Parm$(x)))
  IF UCASE$(Parm$(x)) = "BU" THEN
    Backup = True
  ELSEIF UCASE$(LEFT$(Parm$(x), 2)) = "P:" THEN
    NewPath = UCASE$(RIGHT$(Parm$(x), LEN(Parm$(x)) - 2))
  ELSEIF UCASE$(Parm$(x)) = "103D" THEN
    V103D = True
  END IF
NEXT x
END SUB

DEFSNG A-Z
SUB ParseShipFac
  'This routine parses the ship factors of the ship currently stored in the
  'ShipType variable. These routines and I make no claim to be perfect (since
  'neither of us are), but this does give one a (*very*) general idea of how
  'use(ful/less) this ship is.

SM& = ShipType.MaxHolds
MMR& = MR

MMFac = ((SM& * MMR&) + (ASC(ShipType.TWD) * 20&) + (ASC(ShipType.LRS) * 10&)) * 2.5
  'A rough measure of how well this ship can make money.
OffFac = ((Odds * (ShipType.MaxFtr / 10)) + ShipType.MaxFtrAtt) + (ASC(ShipType.PLS) * 200&) + (ShipType.MaxPHM * 10&) + ShipType.MaxMines
  'Its approximate offensive capability.
DefFac = (Odds * (ShipType.MaxShi / 10)) + (ASC(ShipType.LRS) * 50&)
  'Its approximate defensive capability.
ShipFac = (MMFac) + (OffFac) + (DefFac) - INT(ShipPrice / 10)
  'A generically applicable rating of the ship. (In plain English, only useful
  'if you haven't engineered it for a special purpose like laying mines)
IF ShipFac < 0 THEN ShipFac = 0
  'A negative Overall Factor tends to ruin your whole day.
END SUB

SUB PutData (To$, Mode%)

IF Mode% = 1 THEN
  ShipType = WorkSpace(WShipNum)
  ShipAbb = Abbs(WShipNum)
  RawString = Names(WShipNum)
  IF ShipNum = 9 THEN Align = WAlign
END IF

IF To$ = "........" THEN
  IF V103D THEN
    PUT #2, 85399 + (ShipNum * 23), RawString
    PUT #2, 84612 + (ShipNum * 7), ShipAbb
    IF ShipNum = 9 THEN PUT #4, 238171, Align
  ELSE
    PUT #2, 84654 + ((ShipNum - 1) * 23), RawString
    PUT #2, 83851 + ((ShipNum - 1) * 7), ShipAbb
    IF ShipNum = 9 THEN PUT #4, 238152, Align
  END IF
  PUT #1, ShipNum + 1, ShipType
ELSE
  OPEN NewPath + To$ FOR BINARY AS #7
  IF LOF(7) > 25 THEN GET #7, 1, FileHeader
  IF LOF(7) = 0 THEN
    CLOSE #7
    KILL NewPath + To$ + ".KIT"
    COLOR 12
    PRINT "Failed!"
    PRINT LTRIM$(RTRIM$(To$)) + " does not exist."
    EXIT SUB
  ELSEIF LOF(7) <> 1083 OR FileHeader <> "TW2002 ShipEdit Kit File" + CHR$(26) THEN
    COLOR 12
    PRINT "Failed!"
    CLOSE #7
    PRINT LTRIM$(RTRIM$(To$)) + " was an invalid ShipKit."
    EXIT SUB
  END IF
  PUT #7, 26, Align
  PUT #7, KitNum, RawString
  PUT #7, KitNum + 23, ShipAbb
  PUT #7, KitNum + 29, ShipType.HoldCost
  PUT #7, KitNum + 31, ShipType.DrivCost
  PUT #7, KitNum + 33, ShipType.CompCost
  PUT #7, KitNum + 35, ShipType.HullCost
  PUT #7, KitNum + 37, ShipType.MaxHolds
  PUT #7, KitNum + 39, ShipType.InitHolds
  PUT #7, KitNum + 41, ShipType.MoveRate
  PUT #7, KitNum + 47, ShipType.MaxFtr
  PUT #7, KitNum + 49, ShipType.MaxShi
  PUT #7, KitNum + 51, ShipType.OffOdds
  PUT #7, KitNum + 53, ShipType.MaxMines
  PUT #7, KitNum + 55, ShipType.MaxBeac
  PUT #7, KitNum + 57, ShipType.MaxGen
  PUT #7, KitNum + 59, ShipType.LRS
  PUT #7, KitNum + 60, ShipType.TWD
  PUT #7, KitNum + 61, ShipType.PLS
  PUT #7, KitNum + 62, ShipType.MaxPHM
  PUT #7, KitNum + 64, ShipType.MaxFtrAtt
  CLOSE #7
END IF
END SUB

FUNCTION SFill$ (StringVar$, MaxLen%)
IF LEN(StringVar$) > MaxLen% THEN SFill$ = "" ELSE SFill$ = STRING$(MaxLen% - LEN(StringVar$), 32)
END FUNCTION

SUB ShowMenu
PRINT
Pstra ("~E[~DShipEdit KitWorks v0.10~E]ͻ~!")
Pstra (" ~BWorkSpace ~A: ~D")
IF Work = "............" THEN
  Pstra ("~GTradeWars      ~E~!")
ELSEIF Work = Blank THEN
  Pstra ("~BNothing Loaded ~E~!")
ELSE
  Pstra (Work + "   ~E~!")
END IF
Pstra ("ķ~!")
Pstra ("~h~A<~BI~A]~Enstall a Kit on this copy of TW2002          ~!")
Pstra ("~h~A<~BC~A]~Ereate a Kit from this copy of TW2002         ~!")
Pstra ("~h~A<~BD~A]~Eisplay All ShipKits in this directory        ~!")
Pstra ("~h~A<~BE~A]~Extract Ships To and From Workspace           ~!")
Pstra ("~h~A<~BL~A]~Eoad a set of ShipTypes into Workspace        ~!")
Pstra ("~h~A<~BS~A]~Ehow Summary Screen of ShipTypes in Workspace ~!")
Pstra ("~h~A<~B?~A] ~DHelp" + STRING$(40, 32) + "~E~!")
Pstra ("~h~A<~BQ~A] ~DQuit" + STRING$(40, 32) + "~E~!")
Pstra ("Ľ~!")
Pstra ("[~GCommand~E] ~e: ~D")
END SUB

DEFINT A-Z
SUB Summary
'
COLOR 3, 0
CLS
ShipNum = 0
PRINT " ĳ     Ŀ  ĳ Ŀ  Ŀ    "; : COLOR 11: PRINT "Summary of Individual and Group"
COLOR 3: PRINT "Ŀ  Ŀ   ĳ              "; : COLOR 11: PRINT "ShipTypes"
PRINT ""; : COLOR 3: PRINT ""; : COLOR 11: PRINT ""; : COLOR 3: PRINT " "; : COLOR 11: PRINT ""; : COLOR 3: PRINT ""; : COLOR 11: PRINT ""; : COLOR 3: PRINT ""; : COLOR 11: PRINT ""; : COLOR 3: PRINT "   "; : COLOR 11: PRINT "";
COLOR 3: PRINT ""; : COLOR 11: PRINT ""; : COLOR 3: PRINT " "; : COLOR 11: PRINT ""; : COLOR 3: PRINT "  "; : COLOR 11: PRINT ""; : COLOR 3: PRINT "";
COLOR 9: PRINT ""
COLOR 8: PRINT ""; : COLOR 4: PRINT ""; : COLOR 12: PRINT ""; : COLOR 14: PRINT "Ship Factors/Yours"; : COLOR 12: PRINT ""; : COLOR 4: PRINT ""; : COLOR 8: PRINT "Ŀ"; : COLOR 4: PRINT ""; : COLOR 12: PRINT "";
COLOR 14: PRINT "Overall/Yours"; : COLOR 12: PRINT ""; : COLOR 4: PRINT ""; : COLOR 8: PRINT "Ŀ"
PRINT " "; : COLOR 12: PRINT "Ship Abb/# "; : COLOR 8: PRINT " "; : COLOR 12: PRINT "Off Fac "; : COLOR 8: PRINT " "; : COLOR 12: PRINT "Def Fac "; : COLOR 8: PRINT " "; : COLOR 12: PRINT "Fin Fac "; : COLOR 8: PRINT " "; : COLOR 12
PRINT "Ovr Fac "; : COLOR 8: PRINT " "; : COLOR 12: PRINT "Average Overall Ship  "; : COLOR 8: PRINT ""
PRINT "Ĵ "; : COLOR 12: PRINT "Factor:               "; : COLOR 8: PRINT ""
PRINT "                                                 "; : COLOR 12: PRINT "Deviation:            "; : COLOR 8: PRINT ""
PRINT ""
COLOR 8: PRINT ""; : COLOR 4: PRINT ""; : COLOR 12: PRINT ""; : COLOR 14: PRINT "Ship Factors/Standard"; : COLOR 12: PRINT ""; : COLOR 4: PRINT ""; : COLOR 8: PRINT "Ŀ"; : COLOR 4: PRINT ""; : COLOR 12: PRINT "";
COLOR 14: PRINT "Overall/Standard"; : COLOR 12: PRINT ""; : COLOR 4: PRINT ""; : COLOR 8: PRINT ""
PRINT " "; : COLOR 12: PRINT "Ship Abb/# "; : COLOR 8: PRINT " "; : COLOR 12: PRINT "Off Fac "; : COLOR 8: PRINT " "; : COLOR 12: PRINT "Def Fac "; : COLOR 8: PRINT " "; : COLOR 12: PRINT "Fin Fac "; : COLOR 8: PRINT " "; : COLOR 12
PRINT "Ovr Fac "; : COLOR 8: PRINT " "; : COLOR 12: PRINT "Average Overall Ship  "; : COLOR 8: PRINT ""
PRINT "Ĵ "; : COLOR 12: PRINT "Factor:               "; : COLOR 8: PRINT ""
PRINT "                                                                       "
PRINT ""
COLOR 9: PRINT ""
COLOR 14: PRINT " [ "; : COLOR 9: PRINT " "; : COLOR 11: PRINT "Back one ShipType"
COLOR 14: PRINT " ] "; : COLOR 9: PRINT " "; : COLOR 11: PRINT "Forward one ShipType"
COLOR 14: PRINT " Q "; : COLOR 9: PRINT " "; : COLOR 11: PRINT "Quit Summary and Return to ShipEdit"
'
LOCATE 3, 39
COLOR 27
PRINT "Computing..."
DIM Standards(15, 1 TO 4) AS LONG
DIM StandNames(15) AS STRING * 6
StandNames(0) = "EscPod"
StandNames(1) = "MerCru"
StandNames(2) = "ScoMar"
StandNames(3) = "MisFri"
StandNames(4) = "Battle"
StandNames(5) = "CorFla"
StandNames(6) = "ColTra"
StandNames(7) = "CarTra"
StandNames(8) = "MerFre"
StandNames(9) = "ImpSta"
StandNames(10) = "HavGun"
StandNames(11) = "StaMas"
StandNames(12) = "Constl"
StandNames(13) = "TkhOri"
StandNames(14) = "ThoSen"
StandNames(15) = "TauMul"
'
Standards(0, 1) = 14
Standards(0, 2) = 54
Standards(0, 3) = 650
Standards(0, 4) = 0
Standards(1, 1) = 1500
Standards(1, 2) = 90
Standards(1, 3) = 18775
Standards(1, 4) = 17735
Standards(2, 1) = 500
Standards(2, 2) = 70
Standards(2, 3) = 12525
Standards(2, 4) = 11775
Standards(3, 1) = 2755
Standards(3, 2) = 52
Standards(3, 3) = 15000
Standards(3, 4) = 14927
Standards(4, 1) = 4825
Standards(4, 2) = 170
Standards(4, 3) = 16625
Standards(4, 4) = 17570
Standards(5, 1) = 8700
Standards(5, 2) = 230
Standards(5, 3) = 21325
Standards(5, 4) = 23155
Standards(6, 1) = 312
Standards(6, 2) = 80
Standards(6, 3) = 36275
Standards(6, 4) = 31227
Standards(7, 1) = 358
Standards(7, 2) = 114
Standards(7, 3) = 20962
Standards(7, 4) = 15494
Standards(8, 1) = 326
Standards(8, 2) = 90
Standards(8, 3) = 22525
Standards(8, 4) = 19321
Standards(9, 1) = 14875
Standards(9, 2) = 350
Standards(9, 3) = 31200
Standards(9, 4) = 33565
Standards(10, 1) = 1865
Standards(10, 2) = 110
Standards(10, 3) = 12575
Standards(10, 4) = 11600
Standards(11, 1) = 2950
Standards(11, 2) = 190
Standards(11, 3) = 23300
Standards(11, 4) = 21640
Standards(12, 1) = 2925
Standards(12, 2) = 155
Standards(12, 3) = 17525
Standards(12, 4) = 16555
Standards(13, 1) = 538
Standards(13, 2) = 133
Standards(13, 3) = 19975
Standards(13, 4) = 17046
Standards(14, 1) = 1350
Standards(14, 2) = 150
Standards(14, 3) = 11275
Standards(14, 4) = 10075
Standards(15, 1) = 365
Standards(15, 2) = 75
Standards(15, 3) = 31150
Standards(15, 4) = 26230
'Yes, I'm sure there are a dozen ways I could've drastically reduced the size
'of that code--but I didn't feel like it.
'
SN = ShipNum
FOR ShipNum = 0 TO 15
  ShipType = WorkSpace(ShipNum)
  Odds = ShipType.OffOdds / 10
  MR = 100 * (P6RtoDBL(ShipType.MoveRate))
  Holds& = ShipType.HoldCost
  Drive& = ShipType.DrivCost
  Compu& = ShipType.CompCost
  Hulls& = ShipType.HullCost
  ShipPrice = Holds& + Drive& + Compu& + Hulls&
  ParseShipFac
  Accum& = Accum& + ShipFac
NEXT ShipNum
ShipNum = SN
Average& = Accum& \ 16&
Accum& = 0&
LOCATE 3, 39
COLOR 11
PRINT "            "
'
ShNum = ShipNum
DO
  COLOR 11
  ShipType = WorkSpace(ShipNum)
  ShipAbb = Abbs(ShipNum)
  RawString = Names(ShipNum)
  Align = WAlign
  Odds = ShipType.OffOdds / 10
  MR = 100 * (P6RtoDBL(ShipType.MoveRate))
  Holds& = ShipType.HoldCost
  Drive& = ShipType.DrivCost
  Compu& = ShipType.CompCost
  Hulls& = ShipType.HullCost
  ShipPrice = Holds& + Drive& + Compu& + Hulls&
  ParseShipFac
  LOCATE 8, 3
  PRINT ShipAbb; " #"; CVal$(ShipNum); " ";
  LOCATE 8, 16
  PRINT CLon$(OffFac); SFill$(CLon$(OffFac), 7);
  LOCATE 8, 26
  PRINT CLon$(DefFac); SFill$(CLon$(DefFac), 7);
  LOCATE 8, 36
  PRINT CLon$(MMFac); SFill$(CLon$(MMFac), 7);
  LOCATE 8, 46
  PRINT CLon$(ShipFac); SFill$(CLon$(ShipFac), 7);
  LOCATE 7, 65
  PRINT CLon$(Average&); SFill$(CLon$(Average&), 7);
  LOCATE 8, 68
  Dev& = Average& - 17994&
  IF Dev& > 0 THEN PRINT "+"; CLon$(Dev&) ELSE PRINT CLon$(Dev&)
 
  LOCATE 13, 3
  PRINT StandNames(ShipNum); " #"; CVal$(ShipNum); " ";
  LOCATE 13, 16
  PRINT CLon$(Standards(ShipNum, 1)); SFill$(CLon$(Standards(ShipNum, 1)), 7);
  LOCATE 13, 26
  PRINT CLon$(Standards(ShipNum, 2)); SFill$(CLon$(Standards(ShipNum, 2)), 7);
  LOCATE 13, 36
  PRINT CLon$(Standards(ShipNum, 3)); SFill$(CLon$(Standards(ShipNum, 3)), 7);
  LOCATE 13, 46
  PRINT CLon$(Standards(ShipNum, 4)); SFill$(CLon$(Standards(ShipNum, 4)), 7);
  LOCATE 12, 65
  PRINT "17994";
 
  a$ = UCASE$(GetKey("[]Qq"))
  SELECT CASE a$
    CASE "["
      IF ShipNum = 0 THEN ShipNum = 15 ELSE ShipNum = ShipNum - 1
    CASE "]"
      IF ShipNum = 15 THEN ShipNum = 0 ELSE ShipNum = ShipNum + 1
    CASE "Q"
      ShipNum = ShNum
      EXIT SUB
  END SELECT
LOOP
'Lotsa fun. I dare you to try to figure out my coding on this one.
END SUB

